﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ProgressTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        void StartForm(ProgressForm form)
        {
            //check how the background worker finished
            DialogResult result = form.ShowDialog();
            if (result == DialogResult.Cancel)
                MessageBox.Show("Operation has been cancelled");
            if (result == DialogResult.Abort)
                MessageBox.Show("Exception:" + Environment.NewLine + form.Result.Error.Message);
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            ProgressForm form = new ProgressForm();
            form.Text = "Testing the form";
            //pass the check box state as an argument for our background worker
            form.Argument = checkBoxThrowException.Checked;
            form.DoWork += new ProgressForm.DoWorkEventHandler(form_DoWork);
            StartForm(form);
        }

        void form_DoWork(ProgressForm sender, DoWorkEventArgs e)
        {
            bool throwException = (bool)e.Argument;

            for (int i = 0; i < 100; i++)
            {
                if (throwException && i == 50)
                    throw new Exception("Throwing exception!");

                System.Threading.Thread.Sleep(50);
                sender.SetProgress(i, "Step " + i.ToString() + " / 100...");
                if (sender.CancellationPending)
                {
                    e.Cancel = true;
                    return;
                }
            }
        }
    }
}
